#include <SPI.h>
#include <Wire.h>
#include "RTClib.h"

// INA226
#include <WiFi.h>
#include <HTTPClient.h>
#include <INA226_WE.h>
#define I2C_ADDRESS 0x40 //alamat I2C

// Config Wifi
const char *ssid = "KOSTR5";            //Nama Wifi
const char *password = "tanyapakjoko";  // pass wifi
INA226_WE ina226 = INA226_WE(I2C_ADDRESS);

//Global Variable
float shuntVoltage_mV = 0.0;
float loadVoltage_V = 0.0;
float busVoltage_V = 0.0;
float current_A = 0.0;
float power_mW = 0.0;

unsigned long previousMillis = 0;  // variabel untuk menyimpan waktu terakhir pembaruan
const long interval = 10000;       // interval waktu dalam milidetik


RTC_DS3231 rtc;
char daysOfTheWeek[7][12] = { "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday" };




const int RELAY_1 = 33;
const int RELAY_2 = 25;
const int RELAY_5 = 32;

int LDR_PIN_1 = 34;
int LDR_PIN_2 = 35;


int ldrValue1;
int ldrValue2;


void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);

  Wire.begin();
  ina226.init();

  connectToWifi();

  ina226.setResistorRange(0.075, 50.0);  // choose resistor 5 mOhm and gain range up to 10 A
  ina226.setCorrectionFactor(1.0);
  if (!rtc.begin()) {
    Serial.println("Couldn't find RTC");
    while (1)
      ;
  }

  rtc.adjust(DateTime(__DATE__, __TIME__));

  pinMode(LDR_PIN_1, INPUT);
  pinMode(LDR_PIN_2, INPUT);

  pinMode(RELAY_1, OUTPUT);
  pinMode(RELAY_2, OUTPUT);
  pinMode(RELAY_5, OUTPUT);

  digitalWrite(RELAY_1, HIGH);
  digitalWrite(RELAY_2, HIGH);
  digitalWrite(RELAY_5, HIGH);
  delay(500);

  
}

void loop() {
  DateTime now = rtc.now();

  int hour = now.hour();
  int minute = now.minute();
  int second = now.second();


  ldrValue1 = digitalRead(LDR_PIN_1);
  ldrValue2 = digitalRead(LDR_PIN_2);

  Serial.println(ldrValue1);
  Serial.println(ldrValue2);

  delay(100);
  showTime();

  Serial.println(minute);
  // mengaktifkan alat relay suplai power
  if (hour >= 7 && minute >= 0) {
    digitalWrite(RELAY_1, LOW);
    Serial.println("Relay 4 CH nyala");
    delay(100);
  }
  //mematikan alat relay suplay power
 if (hour >= 18 && minute > 0) {
    digitalWrite(RELAY_1, HIGH);
    Serial.println("Relay 4 CH mati");
    delay(100);
}

  //reset panel ke popsisi  awal
  if (hour == 17 && minute == 58 && second >= 0) {
    digitalWrite(RELAY_2, LOW);
    delay(10);
  } else if (hour == 17 && minute == 58 && second >= 20) {
    digitalWrite(RELAY_2, HIGH);
    delay(10);
  }

  // Logika untuk relay 2 berdasarkan nilai LDR
  if (ldrValue1 == 0) {
    digitalWrite(RELAY_2, LOW);
    Serial.println("nyala1");
    delay(100);
  } else {
    digitalWrite(RELAY_2, HIGH);
    Serial.println("mati1");
    delay(100);
  }

  // Logika untuk relay 5 berdasarkan nilai LDR
  if (ldrValue2 == 0) {
    digitalWrite(RELAY_5, LOW);
    Serial.println("nyala1");
    delay(100);
  } else {
    digitalWrite(RELAY_5, HIGH);
    Serial.println("mati1");
    delay(100);
  }


  //Perluangan tiap 10 meniit sekali dengan waktu RTC
  // if (minute % 10 == 0 && second == 0) {
  //   bacaSensor();
  //   Serial.println("Data terbaca");
  //   delay(1000);
  //   kirim_data();
  //   Serial.println("Data terkirim");
  // }

  // bacaSensor();
  // Serial.println("Data terbaca");
  // delay(1000);
  // kirim_data();
  // Serial.println("Data terkirim");

  //Perluangan tiap 10 meniit sekali dan mengambil data dari jam 7-18 wib dengan waktu RTC
    if (hour >= 7 && hour < 18) {
    if (minute % 10 == 0 && second == 0) {
      bacaSensor(); // Memanggil fungsi untuk membaca sensor
      Serial.println("Data terbaca");
      delay(1000);
      kirim_data(); // Memanggil fungsi untuk mengirim data
      Serial.println("Data terkirim");
    }
  } else {
    Serial.println("Tidak mengirim data (18.00 - 07.00 WIB)");
  }
}


void showTime() {
  DateTime now = rtc.now();
  Serial.print(now.hour(), DEC);
  Serial.print(":");
  if (now.minute() < 10) {
    Serial.print("0");
  }
  Serial.print(now.minute(), DEC);
  Serial.print(":");
  if (now.second() < 10) {
    Serial.print("0");
  }
  Serial.print(now.second(), DEC);
  Serial.print(" ");

  Serial.print(daysOfTheWeek[now.dayOfTheWeek()]);
  Serial.print(" ");

  Serial.print(now.day(), DEC);
  Serial.print("-");
  Serial.print(now.month(), DEC);
  Serial.print("-");
  Serial.println(now.year(), DEC);
}

void bacaSensor() {
  ina226.readAndClearFlags();
  shuntVoltage_mV = ina226.getShuntVoltage_mV();
  busVoltage_V = ina226.getBusVoltage_V();
  current_A = ina226.getCurrent_mA() /1000;
  power_mW = ina226.getBusPower();
  loadVoltage_V = busVoltage_V + (shuntVoltage_mV / 1000);

  Serial.print("Shunt Voltage [mV]: ");
  Serial.println(shuntVoltage_mV);
  Serial.print("Bus Voltage [V]: ");
  Serial.println(busVoltage_V);
  Serial.print("Load Voltage [V]: ");
  Serial.println(loadVoltage_V);
  Serial.print("Current[A]: ");
  Serial.println(current_A);
  Serial.print("Bus Power [mW]: ");
  Serial.println(power_mW);
  if (!ina226.overflow) {
    Serial.println("Values OK - no overflow");
  } else {
    Serial.println("Overflow! Choose higher current range");
  }
  Serial.println();
}

void kirim_data() {

  int kelembaban = random(10, 20);

  String postData = (String) "tegangan=" + loadVoltage_V + "&arus=" + current_A;

  HTTPClient http;
  http.begin("http://192.168.18.26/esp32_http/api2.php"); //mengirim ke database localhost melalui file api.php
  http.addHeader("Content-Type", "application/x-www-form-urlencoded");

  auto httpCode = http.POST(postData);
  String payload = http.getString();

  Serial.println(postData);
  Serial.println(payload);

  http.end();
}

void connectToWifi() {
  delay(1000);
  WiFi.mode(WIFI_OFF);
  delay(1000);
  WiFi.mode(WIFI_STA);

  WiFi.begin(ssid, password);
  Serial.println("");

  Serial.print("Connecting");
  // Wait for connection
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }

  Serial.println("");
  Serial.print("Connected to ");
  Serial.println(ssid);
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());  //IP address assigned to your ESP
}