<?php
// database.php
$host = 'localhost';
$db   = 'monitoringdaya';
$user = 'root';
$pass = '';
$charset = 'utf8mb4';

$dsn = "mysql:host=$host;dbname=$db;charset=$charset";
$options = [
    PDO::ATTR_ERRMODE            => PDO::ERRMODE_EXCEPTION,
    PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC,
    PDO::ATTR_EMULATE_PREPARES   => false,
];

try {
    $pdo = new PDO($dsn, $user, $pass, $options);
} catch (\PDOException $e) {
    throw new \PDOException($e->getMessage(), (int)$e->getCode());
}

function getData($date = null) {
    global $pdo;
    
    $query = "SELECT tegangan, arus, waktu FROM sensor";
    $params = [];
    
    if ($date) {
        $query .= " WHERE DATE(waktu) = ?";
        $params = [$date];
    }
    
    $query .= " ORDER BY waktu";
    
    $stmt = $pdo->prepare($query);
    $stmt->execute($params);
    return $stmt->fetchAll();
}